﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Http;

using DataLayerEF;
using DataLayerEF.Entities;
using System.Net;

// Demo della sessione su MVC4 Beta WebApi (Ex WCF) - http://www.communitydays.it/events/communitydays-2012/
// Raffaele Rialdi raffaeler@vevy.com - @raffaeler - http://iamraf.net

namespace AW1.Controllers
{
	public class CustomersController : ApiController
	{
		private NorthwindContext ctx = new NorthwindContext();

		protected override void Dispose(bool disposing)
		{
			if(ctx != null)
				ctx.Dispose();

			base.Dispose(disposing);
		}

		// GET /api/customers/5
		public Customer GetItem(string id)
		{
			//var item = ctx.Customers.Include("Orders").Where(c => c.CustomerID == id).FirstOrDefault();
			var item = ctx.Customers.Where(c => c.CustomerID == id).FirstOrDefault();
			return item;
		}


		// risponde a "/customers"
		// permette query stile oData
		public IQueryable<Customer> GetItems()
		{
			//return ctx.Customers.Include("Orders");
			return ctx.Customers;
		}

		// risponde a "/customers/"
		// permette query stile oData
		//[WebGet(UriTemplate = "bycity/{city}")]
		public IQueryable<Customer> GetByCity(string city)
		{
			return ctx.Customers.Where(c => c.City.StartsWith(city));
		}


		// risponde a "/customers/"
		public Customer Post(Customer customer)
		{
			ctx.Customers.Add(customer);
			ctx.SaveChanges();
			return customer;
		}

		// risponde a "/customers/id"
		[HttpPut]
		public Customer Put(string id, Customer customer)
		{
			ctx.Customers.Attach(customer);
			var ctx2 = ((System.Data.Entity.Infrastructure.IObjectContextAdapter)ctx).ObjectContext;
			ctx2.ObjectStateManager.ChangeObjectState(customer, System.Data.EntityState.Modified);

			ctx.SaveChanges();
			return customer;
		}

		// risponde a "/customers/id"
		public void Delete(string id)
		{
			var customer = ctx.Customers.Where(c => c.CustomerID == id).FirstOrDefault();
			if(customer == null)
				throw new HttpResponseException(HttpStatusCode.NotFound);
			ctx.Customers.Remove(customer);
			ctx.SaveChanges();
		}













		//// POST /api/customers
		//public void Post(string value)
		//{
		//}

		//// PUT /api/customers/5
		//public void Put(int id, string value)
		//{
		//}

		//// DELETE /api/customers/5
		//public void Delete(int id)
		//{
		//}
	}
}
