﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Http;

using DataLayerEF;
using DataLayerEF.Entities;
using System.Net;

// Demo della sessione su MVC4 Beta WebApi (Ex WCF) - http://www.communitydays.it/events/communitydays-2012/
// Raffaele Rialdi raffaeler@vevy.com - @raffaeler - http://iamraf.net

namespace AW2.Controllers
{
	public class CustomersController : ApiController
	{
		private NorthwindContext ctx = new NorthwindContext();

		protected override void Dispose(bool disposing)
		{
			if(ctx != null)
				ctx.Dispose();

			base.Dispose(disposing);
		}

		// GET /api/customers/5
		public HttpResponseMessage<Customer> GetItem(HttpRequestMessage request, string id)
		{
			var item = ctx.Customers.Where(c => c.CustomerID == id).FirstOrDefault();
			var response = new HttpResponseMessage<Customer>(item);

			return response;
		}


		// risponde a "/customers"
		// permette query stile oData
		public HttpResponseMessage<IQueryable<Customer>> GetItems()
		{
			var items = ctx.Customers;
			var response = new HttpResponseMessage<IQueryable<Customer>>(items);
			return response;
		}


	}
}
