﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Http;

using DataLayerEF;
using DataLayerEF.Entities;

// Demo della sessione su MVC4 Beta WebApi (Ex WCF) - http://www.communitydays.it/events/communitydays-2012/
// Raffaele Rialdi raffaeler@vevy.com - @raffaeler - http://iamraf.net


namespace AW3.Controllers
{
	public class CategoriesController : ApiController
	{
		private NorthwindContext ctx = new NorthwindContext();

		protected override void Dispose(bool disposing)
		{
			if(ctx != null)
				ctx.Dispose();

			base.Dispose(disposing);
		}


		// risponde a "/contacts/id"
		//public HttpResponseMessage<Category> GetItem(HttpRequestMessage request, string name)
		public Category GetItem(HttpRequestMessage request, string name)
		{
			var item = ctx.Categories.Where(c => c.CategoryName == name).FirstOrDefault();
			//item.Picture = null;	// evito di trasferire l'immagine con la entity

			return item;
			//var response = new HttpResponseMessage<Category>(item);
			//return response;
		}

		// risponde a "/categories"
		// permette query stile oData
		public IQueryable<Category> GetItems()
		{
			return ctx.Categories;
		}



	}
}
