﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Net.Http;
using System.Threading.Tasks;
using System.Net.Http.Formatting;

// Demo della sessione su MVC4 Beta WebApi (Ex WCF) - http://www.communitydays.it/events/communitydays-2012/
// Raffaele Rialdi raffaeler@vevy.com - @raffaeler - http://iamraf.net


namespace AW3Client
{
	class Program
	{
		static void Main(string[] args)
		{
			new Program().Start();

			Console.WriteLine("");
			Console.WriteLine("=== End ===");
			Console.ReadKey();
		}

		private void Start()
		{
			var address = new Uri("http://localhost:49765/Categories/Beverages", UriKind.Absolute);
			Category category = Get(address, "text/csv");

			Console.WriteLine("Address: {0}", address);
			Console.WriteLine("Id:      {0}", category.CategoryID);
			Console.WriteLine("Name:    {0}", category.CategoryName);
			Console.WriteLine("Descr:   {0}", category.Description);
		}

		private Category Get(Uri address, string mimeType)
		{
			HttpClient client = new HttpClient();

			using(var request = new HttpRequestMessage(HttpMethod.Get, address))
			{
				request.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue(mimeType));
				using(Task<HttpResponseMessage> responseTask = client.SendAsync(request))
				{
					responseTask.Wait();
					var responseMessage = responseTask.Result;


					var category = responseMessage.Content.ReadAsAsync<Category>(new MediaTypeFormatter[] { new CategoryFormatter() }).Result;
					return category;
				}
			}
		}


	}
}
