﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Http;
using AW4.Filters;

// Demo della sessione su MVC4 Beta WebApi (Ex WCF) - http://www.communitydays.it/events/communitydays-2012/
// Raffaele Rialdi raffaeler@vevy.com - @raffaeler - http://iamraf.net


namespace AW4.Controllers
{
	public class CalcController : ApiController
	{
		//[WebGet(UriTemplate = "Sum/{x}/{y}")]
		[HttpGet]
		public double Sum(double x, double y)
		{
			return x + y;
		}

		//[WebGet(UriTemplate = "Sub?x={x}&y={y}")]
		[HttpGet]
		[ReverseParamsFilterAttribute]
		public double Sub(double x, double y)
		{
			System.Threading.Thread.Sleep(500);

			var result = x - y;
			return result;
		}

		//[WebInvoke(UriTemplate = "Mul", Method = "POST")]
		[HttpPost]
		public double Mul(Operands operands)
		{
			return operands.x * operands.y;
		}


		//[WebGet(UriTemplate = "Div?x={x}&y={y}")]
		//[WebInvoke(UriTemplate = "Div?x={x}&y={y}", Method = "POST")]
		[HttpPost]
		public double Div(double x, double y)
		{
			var result = x / y;
			return result;
		}

		//[WebGet(UriTemplate = "Div2?x={x}&y={y}")]
		//[WebInvoke(UriTemplate = "Div2?x={x}&y={y}", Method = "POST")]
		[HttpGet]
		public double Div2(double x, double y)
		{
			if(y == 0)
			{
				throw new HttpResponseException(new HttpResponseMessage(System.Net.HttpStatusCode.BadRequest)
				{
					Content = new StringContent("[Div2] Errore di divisione per zero")
				});
			}
			return x / y;
		}
	}

	public class Operands
	{
		public double x { get; set; }
		public double y { get; set; }
	}
}
