﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using System.Web.Http.Controllers;
using System.Text.RegularExpressions;
using System.Web.Http;
using System.Net.Http;

namespace AW4.Filters
{
	public class EmailValidationFilterAttribute : System.Web.Http.Filters.ActionFilterAttribute
	{
		public override void OnActionExecuting(HttpActionContext actionContext)
		{
			string email;
			if(actionContext.ActionArguments.TryGetValue("email", out email))
			{
				Validate(email);
			}
			base.OnActionExecuting(actionContext);
		}

		private void Validate(string email)
		{
			Regex re = new Regex(@"\b[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}\b");
			if(re.IsMatch(email))
				return;

			throw new HttpResponseException(new HttpResponseMessage(System.Net.HttpStatusCode.BadRequest)
			{
				Content = new StringContent("Email address is not valid")
			});
		}
	}
}