﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;

namespace AW4
{
	// Note: For instructions on enabling IIS6 or IIS7 classic mode, 
	// visit http://go.microsoft.com/?LinkId=9394801

	public class WebApiApplication : System.Web.HttpApplication
	{
		public static void RegisterGlobalFilters(GlobalFilterCollection filters)
		{
			filters.Add(new HandleErrorAttribute());
		}

		public static void RegisterRoutes(RouteCollection routes)
		{
			var config = GlobalConfiguration.Configuration;
			config.MessageHandlers.Add(new Msg.ElapsedTimeMessageHandler());

			//config.ServiceResolver.SetResolver(

			routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

			routes.MapHttpRoute(
				name: "DefaultApi1",
				routeTemplate: "calc/{action}/{x}/{y}",
				defaults: new
				{
					controller = "calc",
					id = RouteParameter.Optional,
					email = RouteParameter.Optional
				}
			);

			routes.MapHttpRoute(
				name: "DefaultApi1b",
				routeTemplate: "calc/{action}",
				defaults: new
				{
					controller = "calc",
					id = RouteParameter.Optional,
					email = RouteParameter.Optional
				}
			);


			routes.MapHttpRoute(
				name: "DefaultApi2b",
				routeTemplate: "contact/NotImplementedFeature",
				defaults: new { controller = "contact", action = "NotImplementedFeature" }
			);
	
			routes.MapHttpRoute(
				name: "DefaultApi2",
				routeTemplate: "contact/{id}/{email}",
				defaults: new { controller = "contact", id = RouteParameter.Optional, email = RouteParameter.Optional }
			);


			routes.MapRoute(
				name: "Default",
				url: "{controller}/{action}/{id}",
				defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional }
			);
		}

		protected void Application_Start()
		{
			AreaRegistration.RegisterAllAreas();

			RegisterGlobalFilters(GlobalFilters.Filters);
			RegisterRoutes(RouteTable.Routes);

			BundleTable.Bundles.RegisterTemplateBundles();
		}
	}
}