﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using System.Diagnostics;
using System.Threading;
using System.Threading.Tasks;
using System.Net.Http;

// Original code from Pedro Felix
// http://pfelix.wordpress.com/2011/08/09/wcf-web-apimessage-handlers/

namespace AW4.Msg
{
	public class ElapsedTimeMessageHandler : DelegatingHandler
	{
		public ElapsedTimeMessageHandler()
		{
		}

		public ElapsedTimeMessageHandler(HttpMessageHandler innerHandler)
			: base(innerHandler)
		{
		}

		protected override Task<HttpResponseMessage> SendAsync(
			HttpRequestMessage request, CancellationToken cancellationToken)
		{
			var sw = new Stopwatch();
			sw.Start();
			return base.SendAsync(request, cancellationToken)
					.ContinueWith(task =>
					{
						sw.Stop();
						task.Result.Headers.Add("X-Elapsed-Time", sw.ElapsedMilliseconds.ToString());
						return task.Result;
					}, TaskContinuationOptions.ExecuteSynchronously);
		}

	}
}